<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="50%"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="form-dialog-box"
    v-loading="loading"
    :element-loading-text="loadingText"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0)">
      <div
        v-loading="loading"
        :element-loading-text="''"
        element-loading-spinner="''"
        element-loading-background="rgba(0, 0, 0, 0.8)"
        >
        <el-form :model="form" ref="form" :rules="rules" label-width="200px">
          <div class="form-title"><span>基本信息</span></div>
          <el-form-item label="办卡类型：" prop="entityCardConfigId">
            <el-select style="width: 100%;" v-model="form.entityCardConfigId" clearable placeholder="请选择卡类型">
              <el-option
                v-for="dict in tableList"
                :key="dict.id"
                :label="dict.cardName"
                :value="dict.id">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="持卡人：" prop="userName">
            <el-input v-model="form.userName" controls-position="right" placeholder="请输入持卡人"></el-input>
          </el-form-item>
          <el-form-item label="身份证号：" prop="idCard">
            <el-input v-model="form.idCard" controls-position="right" placeholder="请输入身份证号"></el-input>
          </el-form-item>
          <el-form-item label="手机号：" prop="phone">
            <div style="display: flex;">
              <el-input v-model="form.phone" controls-position="right" placeholder="请输入手机号"></el-input>
              <el-button @click="getCode" style="margin-left: 20px;" type="primary" :loading="phoneCodeLoading == 1">{{ phoneCodeLoading == 1 ? '获取中...' : phoneCodeLoading == 0 ? '获取验证码' : '已发送成功，重新获取' }}</el-button>
            </div>
          </el-form-item>
          <el-form-item label="短信验证码：" prop="code">
            <el-input v-model="form.code" controls-position="right" placeholder="请输入短信验证码"></el-input>
          </el-form-item>
        </el-form>
      </div>
    </div>
    <span slot="footer" class="dialog-footer" v-if="formStatus==1">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        :loading="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      > 
        {{ loading ? '提交中...' : '保存' }}
      </el-button>
    </span>
    <!-- 添加或修改对话框 End -->
  </el-dialog>
</template>

<script>
import { 
  getTableDeatilsByIdApi,
  updateTableApi,
  addTableApi,
  listTableApi,
 } from '@/api/CURD'

export default {
  name: "addAndEdit",
  dicts: [],
  data() {
    return {
      title: "",
      model: "", // EDIT: 编辑模式 ADD : 新增模式  EDITInit : 编辑模式（需要请求详情）
      open: false,
      loading: false,
      loadingText: "拼命加载数据中...",
      formStatus: null, // 0/null : 加载中 1 : 获取详情成功 2  : 获取详情失败 
      configUrl: {
        add: '/merchant/merchantEntitycard/insertOrUpdate', // 新增地址
        details: '/merchant/merchantEntitycard/selectById', // 详情地址
        edit: '/merchant/merchantEntitycard/insertOrUpdate', // 编辑地址
        list: '/merchant/merchantEntitycardConfig/pageList', // 实体卡类型
        codeList: '/merchant/merchantAuth/getVerifyCode', // 获取验证码
        merchantRealAuth: '/merchant/merchantAuth/merchantRealAuth', // 验证
      },
      form: {
        id: undefined,
      },
      rules: {
        entityCardConfigId: [{ required: true, message: "请选择办卡类型", trigger: ["change","blur"] }],
        userName: [{ required: true, message: "请输入持卡人", trigger: ["change","blur"] }],
        idCard: [{ required: true, message: "请输入身份证号", trigger: ["change","blur"] }],
        phone: [
          { required: true, trigger: ["change","blur"], message: "请输入您的账号" },
          { pattern: /^1[3-9]\d{9}$/, message: '手机号格式不正确', trigger: ["change","blur"] }
        ],
        code: [{ required: true, message: "请输入短信验证码", trigger: ["change","blur"] }],
      },
      scenicAreaProducts: [],// 景点产品关联

      tableList: [], // 实体卡类型

      phoneCodeLoading: 0
    };
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询体卡类型列表 */
    getList() {
      listTableApi(
        this.configUrl.list,
        this.addDateRange({
          pageNum: 1,
          pageSize: 9999,
        })).then(response => {
              this.tableList = response.data.rows;
          }
        ).catch (error=>{
          this.tableList = [];
        }) 
    },
    async initData(title , model,row){
      this.title = title
      this.open = true
      this.loadingText = "拼命加载数据中..."
      this.loading = true
      this.actionUrlLoading = false
      this.model = model
      this.formStatus = 0
      this.phoneCodeLoading = 0
      if(model=='ADD') { // 新增
        this.$set(this,'form',{...row,logo:[]})
        this.formStatus = 1
      }else if(model=='EDIT') { // 新增
        let obj = {
          ...row,
          logo: row.logo?row.logo.split(','):[]
        }
        this.$set(this,'form',obj)
        this.formStatus = 1
      }else if(model=='EDITInit') { // 新增
        await this.getTableDeatilsFun(row)
      }
      this.loading = false
      this.$nextTick(()=>{
        if(this.$refs["form"]) {
          this.$refs["form"].clearValidate();
        }
      })
    },
    /** 获取详情 */
    async getTableDeatilsFun(row) {
      const id = row.id
      this.loading = true
      try {
        let res = await getTableDeatilsByIdApi(this.configUrl.details,{id})
        if(res.code == 200) {
          let obj = {
            ...res.data,
        }
          this.$set(this,'form',JSON.parse(JSON.stringify(obj)))
          this.formStatus = 1
        }else {
          this.$message.error('获取详情失败!!!');
          this.formStatus = 2
          this.loading = false
          this.open = false;
        }
        this.loading = false
      } catch (error) {
        console.error('获取详情失败!!!!',error)
        this.formStatus = 2
        this.loading = false
        this.open = false;
      }
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(async valid => {
        if (valid) {
          this.loadingText = "提交数据中..."
          this.loading = true
          try {
            let resCode = await addTableApi(
              this.configUrl.merchantRealAuth,
              this.addDateRange({
                idCard: this.form.idCard,
                userName: this.form.userName,
            }))
            if(resCode.code == 200) {

            }else {
              return
            }
            if (this.model != 'ADD') {
              let res = await addTableApi(this.configUrl.edit,{...this.form})
              if(res.code == 200) {
                this.$modal.msgSuccess("修改成功");
                this.loading = false
                this.open = false;
                this.$emit('refresh')
              }else {
                this.$message.error("修改失败!!!");
                this.loading = false
              }
            } else {
              let res = await addTableApi(this.configUrl.edit,{...this.form})
              if(res.code == 200) {
                this.$modal.msgSuccess("新增成功");
                this.loading = false
                this.open = false;
                this.$emit('refresh')
              }else {
                this.$message.error("新增失败!!!");
                this.loading = false
              }
            }
          } catch (error) {
            this.$message.error(`${this.form.id?'修改':'新增'}失败!!!`);
            this.loading = false
          }
          
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      if(this.$refs["form"]) {
        this.$refs["form"].clearValidate();
      }
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },
    /**
     * 获取验证码
     */
     getCode() {
      if(this.phoneCodeLoading == 1) return
      let reg = /^1[3-9]\d{9}$/
      if(!reg.test(this.form.phone)) {
        this.$message.error("手机号输入不正确!!!");
        return
      }
      this.phoneCodeLoading = 1
      addTableApi(
        this.configUrl.codeList,
        this.addDateRange({
          phone: this.form.phone,
        })).then(response => {
          this.phoneCodeLoading = 2
        }).catch (error=>{
          this.phoneCodeLoading = 0
        }) 
     },
  },
};
</script>

<style lang="scss" scoped>
.form-dialog-box {
  padding: 0 30px;
  padding: 0 30px;
  min-height: 50vh;
  max-height: 65vh;
  overflow-y: auto;
  >div {
    width: 100%;
    min-height: 50vh;
  }
  .form-title {
    padding: 0 0 10px 0;
    span {
      display: flex;
      color: rgba(65,80,88,1);
      font-size: 16px;
      font-family: SourceHanSansSC;
      font-weight: 700;
      line-height: 23px;
      border-left: 4px solid rgb(22, 132, 252);
      padding-left: 10px;
    }
    
  }
  ::v-deep .ql-editor {
    height: 400px;
  }
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
.el-table{
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}

.area-container {
  min-height: 400px;
}

::v-deep .area-wrap-city.el-cascader {
  line-height: normal;
  .el-input {
    cursor: pointer;
    width: 100% !important;
    height: 28px !important;
    .el-input__inner {
      display: none !important;
    }
    span.el-input__suffix {
      position: inherit !important;
      i.el-input__icon {
        line-height: inherit;
        margin-left: 5px;
      }
    }

    .el-input__wrapper {
      box-shadow: none;
      input {
        display: none;
      }
    }
  }

  .el-cascader__tags {
    display: none;
  }
}

.area-city-popper {
  .el-cascader-panel {
    .el-scrollbar.el-cascader-menu {
      .el-cascader-menu__wrap.el-scrollbar__wrap {
        height: 315px;
      }
    }
  }
}
::v-deep .avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  ::v-deep .avatar-uploader .el-upload:hover {
    border-color: #409EFF;
  }
  ::v-deep .avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 100px;
    height: 100px;
    line-height: 100px;
    text-align: center;
  }
  ::v-deep .avatar {
    width: 100px;
    height: 100px;
    display: block;
  }
</style>
<style>
.custom-class-box {
  z-index: 999999 !important;
}
</style>